// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import lombok.Getter;
import lombok.Setter;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class T2CconfigEnumManager {

    private final List<AdditionalEnum> additionalEnums = new ArrayList<>();

    @Getter
    public static class AdditionalEnum {
        private final String key;
        private String path;
        @Setter
        private Object value;
        private List<String> comments;

        public AdditionalEnum(String key, String path, Object value, String... comments) {
            this.key = key;
            this.path = path;
            this.value = value;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }
    }

    // Method to add or change an "enum" value
    public void set(@NotNull Object key, @NotNull String path, Object value, String... comments) {
        // Check if the key already exists
        for (AdditionalEnum enumValue : additionalEnums) {
            if (enumValue.key.equals(key)) {
                // Update existing enum
                enumValue.path = path;
                enumValue.value = value;
                enumValue.comments = Arrays.asList(comments);
                return;
            }
        }

        // Add new enum
        AdditionalEnum newEnum = new AdditionalEnum(key.toString(), path, value, comments);
        additionalEnums.add(newEnum);
    }

    // Method to retrieve all enums (original and additional)
    public List<AdditionalEnum> getAllEnums() {
        return new ArrayList<>(additionalEnums);
    }

    // Method to retrieve specific enum details
    public AdditionalEnum getValues(Object key) {
        for (AdditionalEnum e : additionalEnums) {
            if (e.key.equals(key.toString())) {
                return e;
            }
        }
        return null;
    }
}
